//	R_Edje.js
//	http://www.pictrix.jp/	Umezawa
//	09.11.22




var _Rhand = ( Math.sqrt( 2.0 ) - 1.0 ) * 4.0 / 3.0;
var _90 = Math.PI * 0.5;


if ( documents.length > 0 && activeDocument.pathItems.length > 0 ){

	main( );

}


function main( )
{
	var	selObj;
	var	obj;
	var	pid = new Array( );
	var	p0 = new Array( 2 );
	var	p1 = new Array( 2 );
	var	p2 = new Array( 2 );
	var	p3 = new Array( 2 );
	var	v1 = new Array( 2 );
	var	v2 = new Array( 2 );
	var	v0 = new Array( 2 );
	var	v3 = new Array( 2 );
	var	mp = new Array( 2 );
	var	mr = new Array( 2 );
	var	ml = new Array( 2 );
	var	np1 = new Array( 2 );
	var	np2= new Array( 2 );
	var	newPos = new Array(  );
	var	wk = new Array( 2 );
	var	o, n, dot, rad, hand, i, j, k, sw, inc;

	selObj = activeDocument.selection;

	for ( o = 0; o < selObj.length; o++ ){
		if ( selObj[ o ].typename == "PathItem" ){
			obj = selObj[ o ];

			inc = 0;
			n = termPid( obj, pid );
			if ( n == 0 ) continue;

			for ( i = 0; i < n; i++ ){
				sw = getVec( obj, pid[ i ][ 0 ] + inc, pid[ i ][ 1 ] + inc, v1, p0, p1 );
				if ( sw ) continue;
				sw = getVec( obj, pid[ i ][ 3 ] + inc, pid[ i ][ 2 ] + inc, v2, p3, p2 );
				if ( sw ) continue;
				dot = VDOT( v1, v2 );
				if ( dot < -0.9995 ) continue;
	
				VADD3( v0, v1, v2 );
				sw = VNORM( v0 );
				if ( sw ) continue;
	
				rad= setPos( v0, v1, v2, v3, p1, p2, mp, np1, np2 );
				if ( rad == 0 ) continue;
	
				if ( dot > 0.99995 ){
					hand = _Rhand * rad; 
				}
				else{
					th = _90 - Math.acos( dot ) * 0.5;
					if ( VDOT( v1, v3 ) > 0.0 ){
						th = Math.PI - th;
					}
					hand = rad * Math.tan( th * 0.25 ) * 4.0 / 3.0;
				}
	
				VADDM3( wk, np1, v1, -hand );
				obj.pathPoints[ pid[ i ][ 1 ] + inc ].anchor = np1;
				obj.pathPoints[ pid[ i ][ 1 ] + inc ].leftDirection = np1;
				obj.pathPoints[ pid[ i ][ 1 ] + inc ].rightDirection = wk;
	
				VADDM3( wk, np2, v2, -hand );
				obj.pathPoints[ pid[ i ][ 2 ] + inc ].anchor = np2;
				obj.pathPoints[ pid[ i ][ 2 ] + inc ].rightDirection = np2;
				obj.pathPoints[ pid[ i ][ 2 ] + inc ].leftDirection = wk;
	
				newPos[ 0 ] = mp;
				insertAnchor( pid[ i ][ 1 ] + inc, 1, obj, newPos );
				k = nextN( pid[ i ][ 1 ] + inc, obj.pathPoints.length );
				VADDM3( ml, mp, v3, -hand );
				VADDM3( mr, mp, v3, hand );
				obj.pathPoints[ k ].leftDirection = ml;
				obj.pathPoints[ k ].rightDirection = mr;
				obj.pathPoints[ k ].pointType = PointType.SMOOTH;
	
				inc++;
			}
		}
	}
}


function setPos( v0, v1, v2, v3, p1, p2, mp, np1, np2 )
{
	var	wk = new Array( 2 );
	var	pv = new Array( 2 );
	var	vp1 = new Array( 2 );
	var	vp2 = new Array( 2 );
	var	cp = new Array( 2 );
	var	w, sw, type;

	VSUB3( pv, p2, p1 );
	sw = VNORM( pv );
	if ( sw ) return ( 0 );

	type = 0;
	if ( VDOT( v1, pv ) < -0.9999 ) type = 1;
	if ( VDOT( v2, pv ) > 0.9999 ) type = 2;

	switch ( type ){
	case 1:	VCOPY( np1, p1 );
		sw = onPos( p1, v0, p2, v2, np2 );
		if ( sw ) return ( 0 );
		sw = onPos( p1, v1, p2, v0, cp );
		if ( sw ) return ( 0 );
		break;

	case 2:	VCOPY( np2, p2 );
		sw = onPos( p2, v0, p1, v1, np1 );
		if ( sw ) return ( 0 );
		sw = onPos( p2, v2, p1, v0, cp );
		if ( sw ) return ( 0 );
		break;

	case 0:	VADD3( vp1, v1, pv );
		sw = VNORM( vp1 );
		if ( sw ) return ( 0 );
		VADD3( vp2, v2, pv );
		sw = VNORM( vp2 );
		if ( sw ) return ( 0 );
		sw = onPos( p2, vp2, p1, vp1, cp );
		if ( sw ) return ( 0 );
		nearPos( p1, v1, cp, np1 );
		nearPos( p2, v2, cp, np2 );
		break;
	}
	VSUB3( wk, cp, np1 );
	w = VLEN( wk );
	VADDM3( mp, cp, v0, -w );
	VSUB3( v3, np2, np1 );
	VNORM( v3 );
	return ( w );
}




function getVec( obj, n1, n2, v,  p1, p2 )
{
	VCOPY( p1, obj.pathPoints[ n1 ].anchor );
	VCOPY( p2, obj.pathPoints[ n2 ].anchor );
	return ( VNORM3( v, p1, p2 ) );
}



function termPid( obj, pid )
{
	var	pnt	= obj.pathPoints;
	var	pcnt	= obj.pathPoints.length;
	var	id	= new Array( );
	var	pos	= new Array( );
	var	left	= new Array( );
	var	right	= new Array( );
	var	type	= new Array( );
	var	sel	= new Array( );
	var	count	= 0;
	var	st	= -1;
	var	i, j, k;

	if ( obj.closed ){
		if ( ! ( pnt[ 0 ].selected == PathPointSelection.ANCHORPOINT && pnt[ pcnt - 1 ].selected != PathPointSelection.ANCHORPOINT ) ){
			k = -1;
			for ( i = 0; i < pcnt; i++ ){
				if ( pnt[ i ].selected != PathPointSelection.ANCHORPOINT ) {
					k = i;
					break;
				}
			}
	
			if ( k == -1 ) return ( 0 );
			st = -1;
			for ( i = k; i < pcnt; i++ ){
				if ( pnt[ i ].selected == PathPointSelection.ANCHORPOINT ) {
					st = i;
					break;
				}
			}
	
			if ( st == -1 ) return ( 0 );
			for ( i = 0; i < pcnt; i++ ){
				pos[ i ] = new Array( 2 );
				left[ i ] = new Array( 2 );
				right[ i ] = new Array( 2 );
				VCOPY( pos[ i ], pnt[ st ].anchor );
				VCOPY( left[ i ], pnt[ st ].leftDirection );
				VCOPY( right[ i ], pnt[ st ].rightDirection );
				type[ i ] = pnt[ st ].pointType;
				sel[ i ] = pnt[ st ].selected;
				st = nextN( st, pcnt );
			}
			obj.setEntirePath( pos );
			pnt = obj.pathPoints;
			for ( i = 0; i < pcnt; i++ ){
				pnt[ i ].leftDirection = left[ i ];
				pnt[ i ].rightDirection = right[ i ];
				pnt[ i ].pointType = type[ i ];
				pnt[ i ].selected = sel[ i ];
			}
		}
	}
	else{
		if ( pnt[ 0 ].selected == PathPointSelection.ANCHORPOINT || 
			pnt[ pcnt - 1 ].selected == PathPointSelection.ANCHORPOINT )
				return ( 0 );
	}

	i = 0;
	while ( i < pcnt ){
		if ( pnt[ i ].selected == PathPointSelection.ANCHORPOINT && pnt[ i + 1 ].selected == PathPointSelection.ANCHORPOINT ){
			k = i;
			pid[ count ] = new Array( 4 );
			pid[ count ][ 0 ] = prevN( k, pcnt );
			pid[ count ][ 1 ] = k; k = nextN( k, pcnt );
			pid[ count ][ 2 ] = k; k = nextN( k, pcnt );
			pid[ count ][ 3 ] = k;
			count++;
			i += 2;
		}
		else{
			i++;
		}
	}

	return ( count );
}




// ***************************************************************************** functions

function nextN( x, count ) { return ( ( x == count - 1 )? 0 : x + 1 ); }

function prevN( x, count ) { return ( ( x == 0 )? count - 1: x - 1 ); }

function crossV( v )
{
	var	s;

	if ( v[ 0 ] ){
		s = -v[ 0 ]; v[ 0 ] = v[ 1 ]; v[ 1 ] = s;
	}else{
		s = -v[ 1 ]; v[ 1 ] = v[ 0 ]; v[ 0 ] = s;
	}
}

function crossV2( c, v )
{
	var	s;

	if ( v[ 0 ] ){
		c[ 0 ] = v[ 1 ]; c[ 1 ] = -v[ 0 ];
	}else{
		c[ 0 ] = -v[ 1 ]; c[ 1 ] = v[ 0 ];
	}
}

function nearPos( op, v, rp, np )
{
	var	wk = new Array( 2 );
	var	dot;

	VSUB3( wk, rp, op );
	dot = VDOT( v, wk );
	VADDM3( np, op, v, dot );
}

function onPos( pp, pv, lp, lv, mp )
{
	var	wk = new Array( 2 );
	var	d1, d2;

	VSUB3( wk, lp, pp );
	d1 = VDOT( pv, wk );
	d2 = VDOT( lv, pv );
	if ( d2 > 1.0 ) d2= 1.0;
	if ( d2 < -1.0 ) d2= -1.0;
	if ( d2 == 0.0 ) return ( -1 );

	d1 /= d2;
	VMUL3( wk, lv, d1 );
	VSUB3( mp, lp, wk );
	return ( 0 );
}

function disp( v )
{
	alert( v[ 0 ] + "     " + v[ 1 ] );
}

function VCOPY( t, s )
{
	t[ 0 ] = s[ 0 ];
	t[ 1 ] = s[ 1 ];
}

function VMID( v1, v2 )
{
	v1[ 0 ] = ( v1[ 0 ] + v2[ 0 ] ) * 0.5;
	v1[ 1 ] = ( v1[ 1 ] + v2[ 1 ] ) * 0.5;
}

function VMID3( v3, v1, v2 )
{
	v3[ 0 ] = ( v1[ 0 ] + v2[ 0 ] ) * 0.5;
	v3[ 1 ] = ( v1[ 1 ] + v2[ 1 ] ) * 0.5;
}

function VADDM3( v3, v1, v2, s )
{
	v3[ 0 ] = v1[ 0 ] + v2[ 0 ] * s;
	v3[ 1 ] = v1[ 1 ] + v2[ 1 ] * s;
}

function VADDM( v1, v2, s )
{
	v1[ 0 ] = v1[ 0 ] + v2[ 0 ] * s;
	v1[ 1 ] = v1[ 1 ] + v2[ 1 ] * s;
}

function VNEG2( v3, v1 )
{
	v3[ 0 ] = -v1[ 0 ];
	v3[ 1 ] = -v1[ 1 ];
}

function VNEG( v1 )
{
	v1[ 0 ] = -v1[ 0 ];
	v1[ 1 ] = -v1[ 1 ];
}

function VNORM3( v3, v1, v2 )	// v3 = ( v1 - v2 ) / len( v1 - v2 )
{
	v3[ 0 ] = v1[ 0 ] - v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] - v2[ 1 ];
	var len = Math.sqrt( v3[ 0 ] * v3[ 0 ] + v3[ 1 ] * v3[ 1 ] );
	if ( len != 0.0 ){
		v3[ 0 ] /= len;
		v3[ 1 ] /= len;
		return 0;
	}
	else{
		v3[ 0 ] = v3[ 1 ] = 0.0;
		return -1;
	}
}

function VNORM2( v2, v1 )		// v2 = v1 / len( v1 )
{
	var len = Math.sqrt( v1[ 0 ] * v1[ 0 ] + v1[ 1 ] * v1[ 1 ] );
	if ( len != 0.0 ){
		v2[ 0 ] = v1[ 0 ] / len;
		v2[ 1 ] = v1[ 1 ] / len;
		return 0;
	}
	else{
		v2[ 0 ] = v2[ 1 ] = 0.0;
		return -1;
	}
}

function VNORM( v )			// v = v / len( v )
{
	var len = Math.sqrt( v[ 0 ] * v[ 0 ] + v[ 1 ] * v[ 1 ] );
	if ( len != 0.0 ){
		v[ 0 ] /= len;
		v[ 1 ] /= len;
		return 0;
	}
	else{
		v[ 0 ] = v[ 1 ] = 0.0;
		return -1;
	}
}

function VSUB3( v3, v1, v2 )
{
	v3[ 0 ] = v1[ 0 ] - v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] - v2[ 1 ];
}

function VADD3( v3, v1, v2 )
{
	v3[ 0 ] = v1[ 0 ] + v2[ 0 ];
	v3[ 1 ] = v1[ 1 ] + v2[ 1 ];
}

function VMUL3( v3, v1, s )
{
	v3[ 0 ] = v1[ 0 ] * s;
	v3[ 1 ] = v1[ 1 ] * s;
}

function VDIV3( v3, v1, s )
{
	v3[ 0 ] = v1[ 0 ] / s;
	v3[ 1 ] = v1[ 1 ] / s;
}

function VSUB( v1, v2 )
{
	v1[ 0 ] -= v2[ 0 ];
	v1[ 1 ] -= v2[ 1 ];
}

function VADD( v1, v2 )
{
	v1[ 0 ] += v2[ 0 ];
	v1[ 1 ] += v2[ 1 ];
}

function VMUL( v1, s )
{
	v1[ 0 ] *= s;
	v1[ 1 ] *= s;
}

function VDIV( v1, s )
{
	v1[ 0 ] /= s;
	v1[ 1 ] /= s;
}

function VDOT( v1, v2 )
{
	return ( v1[ 0 ] * v2[ 0 ] + v1[ 1 ] * v2[ 1 ] );
}

function VLEN( v )
{
	return ( Math.sqrt( v[ 0 ] * v[ 0 ] + v[ 1 ] * v[ 1 ] ) );
}

function VSUBLEN( v1, v2 )		// len( v1 - v2 )
{
	var x = v1[ 0 ] - v2[ 0 ];
	var y = v1[ 1 ] - v2[ 1 ];
	return ( Math.sqrt( x * x + y * y ) );
}

function PosComp( p1, p2 )
{
	return ( ( p1[ 0 ] == p2[ 0 ] ) && ( p1[ 1 ] == p2[ 1 ] ) );
}

function VRANGE( v, r1, r2 )	// 00: no  01: x  10: y  11: xy
{
	var sw = 0;
	if ( ( r1[ 0 ] <= v[ 0 ] && v[ 0 ] <= r2[ 0 ] ) || ( r2[ 0 ] <= v[ 0 ] && v[ 0 ] <= r1[ 0 ] ) ) sw = 1;
	if ( ( r1[ 1 ] <= v[ 1 ] && v[ 1 ] <= r2[ 1 ] ) || ( r2[ 1 ] <= v[ 1 ] && v[ 1 ] <= r1[ 1 ] ) ) sw += 2;
	return sw;
}

function RANGE( v, r1, r2 )		// true: yes  false: no
{
	return ( ( r1 <= v && v <= r2 ) || ( r2 <= v && v <= r1 ) );
}




function insertAnchor( st, n, orgpath, newpos )
{
	var orgcnt	= orgpath.pathPoints.length;
	var orgLeft	= new Array( orgcnt );
	var orgRight	= new Array( orgcnt );
	var orgCorner	= new Array( orgcnt );
	var newAnchor	= new Array( orgcnt + n );
	var pp		= orgpath.pathPoints;
	var i, j, k;

	st++;
	j = 0;
	for ( i = 0; i < st; i++ ){
		newAnchor[ j ]	= pp[ i ].anchor;
		orgLeft[ j ]	= pp[ i ].leftDirection;
		orgRight[ j ]	= pp[ i ].rightDirection;
		orgCorner[ j++ ]	= pp[ i ].pointType;
	}
	for ( i = 0; i < n; i++ ){
		newAnchor[ j++ ]= newpos[ i ];
	}
	for ( i = st; i < orgcnt; i++ ){
		newAnchor[ j ]	= pp[ i ].anchor;
		orgLeft[ j ]	= pp[ i ].leftDirection;
		orgRight[ j ]	= pp[ i ].rightDirection;
		orgCorner[ j++ ]	= pp[ i ].pointType;
	}
	orgpath.setEntirePath( newAnchor );
	k = 0;
	for ( i = 0; i < st; i++ ){
		pp[ k ].leftDirection	= orgLeft[ k ];
		pp[ k ].rightDirection	= orgRight[ k ];
		pp[ k ].pointType	= orgCorner[ k ];
		k++;
	}
	k += n;
	for ( i = st; i < orgcnt; i++ ){
		pp[ k ].leftDirection	= orgLeft[ k ];
		pp[ k ].rightDirection	= orgRight[ k ];
		pp[ k ].pointType	= orgCorner[ k ];
		k++;
	}
}

function inputVal( tx )	// キャンセル[ 0, 0 ] 空入力[ -1, 0 ] 入力[ 1, val ]
{
	var inp, pt, t, num, d;

	inp = prompt( tx, "" );
	if ( inp == null ) return [ 0, 0 ];
	if ( inp == "" ) return [ -1, 0 ];
	t = inp.search( "pt" );
	if ( t >= 0 ){
		pt = 1;
		num = inp.slice( 0, t );
	}
	else{
		t = inp.search( "mm" );
		pt = 0;
		num = ( t >= 0 )? inp.slice( 0, t ) : inp;
	}
	d= eval( num );
	if ( pt == 0 ) d = d * 72.0 / 25.4;
	return [ 1 , d ];
}


function plot( pos)
{
	var	point = activeDocument.pathItems.add();
	point.stroked = true;
	point.setEntirePath( Array( pos ) );
}




function DegToRad( deg )
{
	return ( deg * Math.PI / 180.0 );
}

function RadToDeg( rad )
{
	return ( rad * 180.0 / Math.PI );
}

function PtToMm( pt )
{
	return ( pt * 25.4 / 72.0 );
}
function MmToPt( mm )
{
	return ( mm * 72.0 / 25.4 );
}


